/*
 * Aspera, Inc.
 *
 * Internal.
 *
 * The C wrapper code uses this to implement the FaspConnectionChannel
 * interface, using a socket wrapped in a fasp_stream_socket_wrapper_t.
 */
#pragma once

#include <FaspConnectionChannel.h>
#include <fasp_stream_channel.h>

class FaspSocketChannel : public FaspConnectionChannel {

public:
    FaspSocketChannel(fasp_stream_socket_wrapper_t *w) : w(w) {}

    int
    write(const char *buff, size_t len) {

        return this->w->write(this->w, buff, len);

    }

    int
    read(char *buff, size_t len) {

        int ret, timedout = 0;

        ret = this->w->read(this->w, buff, len, &timedout);
        if (ret == 0 && timedout)
            throw FaspChannelTimeoutException();

        return ret;
    }

    void
    close() {

        this->w->close(this->w);

    }

private:
    fasp_stream_socket_wrapper_t *w;
};
